/* created from create.c                      */
/* simpop_fgl output -> population ibd states */

/* TO DO : 
-- Option for which of 9/15 to do 
-- name the outputs
-- 
*/

#include <stdio.h>
#include <stdlib.h>
#include "simu.h"

int main(int argv, char *argc[])
{

/***** initialise  ************/
    int nout;
    FILE * sim_chroms;
    FILE * metadata;
    FILE * outfifteenibd;	
    FILE * outnineibd;	
    int * ibdfifteencodes;
    int * ibdninecodes;
    int i,j,k;
    int nsnps, npersons;
    int * snp_pos;
    Person * people;
/****** check inputs **********/
   if (argv!=4) 
    {
        fprintf(stdout,"Usage: [simulated_fgl_file] [SNPs_metadata_file] [# of people to create]\n");
        return 1;
    }

    nout = atoi(argc[3]);

    sim_chroms = fopen(argc[1],"r");
    if (!sim_chroms)
    {
        fprintf(stderr,"Error: File %s not found\n",argc[1]);
        return 1;
    }

    metadata = fopen(argc[2],"r");
    if (!metadata)
    {
        fprintf(stderr,"Error: File %s not found\n",argc[2]);
        return 1;
    }

    outfifteenibd = fopen("outfifteenibd.txt","w");
    if (!outfifteenibd)
    {
        fprintf(stderr,"Error: Could not open file outfifteenibd.txt for writing\n");
        return 1;
    }

    outnineibd = fopen("outnineibd.txt","w");
    if (!outnineibd)
    {
        fprintf(stderr,"Error: Could not open file outnineibd.txt for writing\n");
        return 1;
    }

    /* read in number of snps and individuals in the real data
     * as well as the snp locations
     * */
    fscanf(metadata,"%d %*s",&npersons);
    fscanf(metadata,"%d %*s",&nsnps);
    snp_pos = malloc(nsnps*sizeof(int));
    for (i=0;i<nsnps;i++)
    {
        fscanf(metadata,"%d",&snp_pos[i]);
    }

    /* read in the SIMULATED chromosomes from simulation output */
    people = malloc(nout*sizeof(Person));
    for (i=0;i<nout;i++)
    {
        people[i] = read_person(sim_chroms);
    }

/***** calculate states ********/

   for (i=0;i<nout;i++)
   {
        for (j=i+1;j<nout;j++)
        {
            ibdfifteencodes = ibd_fifteen(people[i],people[j],nsnps,snp_pos);
            ibdninecodes = ibd_nine(ibdfifteencodes,nsnps);
            fprintf(outfifteenibd,"%d %d ",people[i].id,people[j].id);
            fprintf(outnineibd,"%d %d ",people[i].id,people[j].id);
            for (k=0;k<nsnps;k++)
            {
                fprintf(outfifteenibd,"%d ",ibdfifteencodes[k]);
                fprintf(outnineibd,"%d ",ibdninecodes[k]);
            }
            fprintf(outfifteenibd,"\n");
            fprintf(outnineibd,"\n");
        }
    }
return 0;
}
